using System;
using System.Collections.Generic;
using System.Text;
using System.Xml.Serialization;
using Barbar.MapReport.Common;

namespace Barbar.MapReport.Common.Drawing {
  /// <summary>
  /// Region s business hodnotou
  /// </summary>
  [XmlType(Namespace = Constants.XmlNamespace)]
  [Serializable]
  public class BusinessRegionList : RegionList, IBusinessValue {
    private decimal m_Value;

    /// <summary>
    /// Business hodnota
    /// </summary>
    public decimal Value {
      get { return m_Value; }
      set { m_Value = value; }
    }

    #region IComparable<IValuable> Members

    /// <summary>
    /// Porovn business hodnoty
    /// </summary>
    /// <param name="other">Druh objekt s business hodnotou</param>
    /// <returns>Vsledek porovnn</returns>
    public int CompareTo(IBusinessValue other) {
      return Value.CompareTo(other.Value);
    }

    #endregion
  }
}
