using System;
using System.Collections.Generic;
using System.Text;
using System.Xml.Serialization;
using System.Drawing;
using Barbar.MapReport.Common;

namespace Barbar.MapReport.Common.Drawing {
  /// <summary>
  /// Reprezentuje region obsahujc informaci o barve
  /// </summary>
  [XmlType(Namespace = Constants.XmlNamespace)]
  [Serializable]
  public class ColoredRegionList : RegionList {
    private SerializedColor m_FillColor;
    private SerializedColor m_StrokeColor;

    /// <summary>
    /// Serializovateln hodnota plnc barvy
    /// </summary>
    public SerializedColor FillColor {
      get { return m_FillColor; }
      set { m_FillColor = value; }
    }

    /// <summary>
    /// Serializovateln hodnota obrysov barvy
    /// </summary>
    public SerializedColor StrokeColor {
      get { return m_StrokeColor; }
      set { m_StrokeColor = value; }
    }
  }
}
