﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Collections.ObjectModel;
using System.Globalization;
using Barbar.MapReport.Common;
using System.Xml.Serialization;

namespace Barbar.MapReport.Common.Drawing.Commands {
  [XmlType(Namespace = Constants.XmlNamespace)]
  [Serializable]
  public class AddLinesCommand : DrawingCommand {
    private Collection<GeoLine> m_Lines = new Collection<GeoLine>();
    private int m_Offset;

    public Collection<GeoLine> Lines {
      get { return m_Lines; }
    }

    public int Offset {
      get { return m_Offset; }
      set { m_Offset = value; }
    }

    public override void Render(IRenderer renderer) {
      renderer.AddLines(this);
    }
  }
}
