﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Collections.ObjectModel;
using System.Drawing;
using System.Xml.Serialization;

namespace Barbar.MapReport.Common.Drawing.Commands {
  [XmlType(Namespace = Constants.XmlNamespace)]
  [Serializable]
  public class AddRegionsWithFixColorCommand : DrawingCommand, IDataLocationProvider {
    private Collection<ColoredRegionList> m_Regions = new Collection<ColoredRegionList>();
    private DataLocation m_DataLocation = new DataLocationInline();
    private int m_StrokeWeight = 1;

    public Collection<ColoredRegionList> Regions {
      get { return m_Regions; }
    }

    public int StrokeWeight {
      get { return m_StrokeWeight; }
      set { m_StrokeWeight = value; }
    }

    public override void Render(IRenderer renderer) {
      renderer.AddRegionsWithFixColor(this);
    }

    #region IDataLocationProvider Members

    public DataLocation DataLocation {
      get { return m_DataLocation; }
      set { m_DataLocation = value; }
    }

    #endregion
  }
}
