using System;
using System.Collections.Generic;
using System.Text;
using System.Xml.Serialization;
using Barbar.MapReport.Common;

namespace Barbar.MapReport.Common.Drawing {
  /// <summary>
  /// Bod s vce business hodnotami
  /// </summary>
  [XmlType(Namespace = Constants.XmlNamespace)]
  public class MultipleBusinessGeoPoint : IGeoPoint {
    private decimal[] m_Values;
    private decimal m_Longitude;
    private decimal m_Latitude;
    private string m_Name;
    private string m_Description;
    private string m_Hyperlink;

    /// <summary>
    /// Vchoz konstruktor
    /// </summary>
    public MultipleBusinessGeoPoint() {
    }

    /// <summary>
    /// Vytvor novou instanci bodu s vce business hodnotami
    /// </summary>
    /// <param name="latitude"></param>
    /// <param name="longitude"></param>
    /// <param name="name"></param>
    /// <param name="values"></param>
    public MultipleBusinessGeoPoint(decimal latitude, decimal longitude, string name, decimal[] values) {
      m_Latitude = latitude;
      m_Longitude = longitude;
      m_Name = name;
      m_Values = values;
    }

    /// <summary>
    /// Vrt pole business hodnot
    /// </summary>
    [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Performance", "CA1819:PropertiesShouldNotReturnArrays")]
    public decimal[] Values {
      get { return m_Values; }
      set { m_Values = value; }
    }

    #region IGeoPoint Members

    /// <summary>
    /// Zemepisn dlka (vchod-zpad)
    /// </summary>
    public decimal Longitude {
      get { return m_Longitude; }
      set { m_Longitude = value; }
    }

    /// <summary>
    /// Zemepisn rka (sever-jih)
    /// </summary>
    public decimal Latitude {
      get { return m_Latitude; }
      set { m_Latitude = value; }
    }

    #endregion

    /// <summary>
    /// Nzev
    /// </summary>
    public string Name {
      get { return m_Name; }
      set { m_Name = value; }
    }

    /// <summary>
    /// Popis
    /// </summary>
    public string Description {
      get { return m_Description; }
      set { m_Description = value; }
    }

    /// <summary>
    /// Hyperlink, na kter bod s vce hodnotami ukazuje
    /// </summary>
    public string Hyperlink {
      get { return m_Hyperlink; }
      set { m_Hyperlink = value; }
    }
  }
}

