using System;
using System.Collections.Generic;
using System.Text;
using System.Xml.Serialization;

using System.Collections.ObjectModel;
using Barbar.MapReport.Common;

namespace Barbar.MapReport.Common.Drawing {
  /// <summary>
  /// Reprezentace regionu (kolekce polygonu)
  /// </summary>
  [XmlType(Namespace = Constants.XmlNamespace)]
  [XmlInclude(typeof(BusinessRegionList))]
  [XmlInclude(typeof(ColoredRegionList))]
  [Serializable]
  public class RegionList {
    private Collection<string> m_RegionIds = new Collection<string>();
    private string m_ToolTip;

    /// <summary>
    /// Kolekce regionu
    /// </summary>
    public Collection<string> RegionIds {
      get { return m_RegionIds; }
    }

    /// <summary>
    /// Tool tip
    /// </summary>
    public string ToolTip {
      get { return m_ToolTip; }
      set { m_ToolTip = value; }
    }
  }
}
