using System;
using System.Collections.Generic;
using System.Text;
using System.Xml.Serialization;
using Barbar.MapReport.Common;

namespace Barbar.MapReport.Common.Drawing.ValueIndicators {
  /// <summary>
  /// Vlastnosti indiktoru hodnot, typu Business
  /// </summary>
  [XmlTypeAttribute(Namespace = Constants.XmlNamespace)]
  [Serializable]
  public class BusinessProperties : BaseProperties {
    private int m_CategoriesCount;
    private LegendDescription[] m_Descriptions;

    /// <summary>
    /// Pocet kategori
    /// </summary>
    public int CategoriesCount {
      get { return m_CategoriesCount; }
      set { m_CategoriesCount = value; }
    }

    /// <summary>
    /// Popisek hodnot
    /// </summary>
    [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Performance", "CA1819:PropertiesShouldNotReturnArrays")]
    public LegendDescription[] Descriptions {
      get { return m_Descriptions; }
      set { m_Descriptions = value; }
    }
  }
}
