using System;
using System.Collections.Generic;
using System.Text;
using System.Xml.Serialization;
using System.Drawing;
using Barbar.MapReport.Common;

namespace Barbar.MapReport.Common.Drawing.ValueIndicators {
  /// <summary>
  /// Popis skupiny agregujicich se bodu
  /// </summary>
  [XmlTypeAttribute(Namespace = Constants.XmlNamespace)]
  [Serializable]
  public class Group {
    private int m_Index;
    private string m_Name;
    private SerializedColor m_Color;

    /// <summary>
    /// Identifikator skupiny - ValueIndicator s prislusnou business hodnotou jako ma Index skupiny spada do teto skupiny
    /// </summary>
    public int Index {
      get { return m_Index; }
      set { m_Index = value; }
    }

    /// <summary>
    /// Nazev skupiny
    /// </summary>
    public string Name {
      get { return m_Name; }
      set { m_Name = value; }
    }

    /// <summary>
    /// Barva skupiny
    /// </summary>
    public SerializedColor Color {
      get { return m_Color; }
      set { m_Color = value; }
    }
  }
}
