using System;
using System.Collections.Generic;
using System.Text;
using System.Xml.Serialization;
using System.Drawing;
using Barbar.MapReport.Common;

namespace Barbar.MapReport.Common.Drawing.ValueIndicators {
  /// <summary>
  /// Vlastnosti dynamickch indiktoru typu Group
  /// </summary>
  [XmlTypeAttribute(Namespace = Constants.XmlNamespace)]
  [Serializable]
  public class GroupProperties : BaseProperties {
    private SerializedColor m_GroupColor;
    private List<Group> m_Groups;
    private string m_ToolTipTemplate = String.Empty;
    private GroupToolTipType m_ToolTipType = GroupToolTipType.Aggregate;
    private int m_MaxToolTipAggregated = 10;

    /// <summary>
    /// Barva seskupench indiktoru z ruznch skupin
    /// </summary>
    public SerializedColor GroupColor {
      get { return m_GroupColor; }
      set { m_GroupColor = value; }
    }

    /// <summary>
    /// Definice jednotlivch skupin
    /// </summary>
    [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1002:DoNotExposeGenericLists"), System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Usage", "CA2227:CollectionPropertiesShouldBeReadOnly")]
    public List<Group> Groups {
      get { return m_Groups; }
      set { m_Groups = value; }
    }

    /// <summary>
    /// Popisek
    /// </summary>
    public string ToolTipTemplate {
      get { return m_ToolTipTemplate; }
      set { m_ToolTipTemplate = value; }
    }

    /// <summary>
    /// Maximalni pocet tooltipu ktere se zagreguji do jednoho skupinoveho
    /// </summary>
    public int MaxToolTipAggregated {
      get { return m_MaxToolTipAggregated; }
      set { m_MaxToolTipAggregated = value; }
    }

    /// <summary>
    /// Typ zpracovn tool tipu
    /// </summary>
    public GroupToolTipType ToolTipType {
      get { return m_ToolTipType; }
      set { m_ToolTipType = value; }
    }
  }
}
