using System;
using System.Collections.Generic;
using System.Text;
using System.Xml.Serialization;
using Barbar.MapReport.Common;

namespace Barbar.MapReport.Common.Drawing.ValueIndicators {
  /// <summary>
  /// Vlastnosti dynamickch indiktoru typu List
  /// </summary>
  [XmlTypeAttribute(Namespace = Constants.XmlNamespace)]
  [Serializable]
  public class ListProperties : BaseProperties {
    private SerializedColor m_Color;
    private string m_ToolTipTemplate;
    private bool m_UnionDifferentValues = true;
    private int m_MaxToolTipAggregated = 10;


    /// <summary>
    /// Barva
    /// </summary>
    public SerializedColor Color {
      get { return m_Color; }
      set { m_Color = value; }
    }

    /// <summary>
    /// Tool tip
    /// </summary>
    public string ToolTipTemplate {
      get { return m_ToolTipTemplate; }
      set { m_ToolTipTemplate = value; }
    }

    /// <summary>
    /// Maximalni pocet tooltipu ktere se zagreguji do jednoho skupinoveho
    /// </summary>
    public int MaxToolTipAggregated {
      get { return m_MaxToolTipAggregated; }
      set { m_MaxToolTipAggregated = value; }
    }

    /// <summary>
    /// Spojovat indikatory s odlisnou business hodnotou
    /// </summary>
    public bool UnionDifferentValues {
      get { return m_UnionDifferentValues; }
      set { m_UnionDifferentValues = value; }
    }
  }
}
