using System;
using System.Collections.Generic;
using System.Text;
using System.Xml.Serialization;
using System.Drawing;

namespace Barbar.MapReport.Common {
  /// <summary>
  /// Barva (serializovateln oblka)
  /// </summary>
  [XmlTypeAttribute(Namespace = Constants.XmlNamespace)]
  [Serializable]
  public class SerializedColor {
    private Color m_Color;

    /// <summary>
    /// Vchoz konstruktor
    /// </summary>
    public SerializedColor() {
    }

    /// <summary>
    /// Konstruktor
    /// </summary>
    /// <param name="color"></param>
    public SerializedColor(Color color) {
      m_Color = color;
    }

    /// <summary>
    /// Barva
    /// </summary>
    [XmlIgnore()]
    public Color Color {
      get { return m_Color; }
      set { m_Color = value; }
    }

    internal byte A {
      get { return m_Color.A; }
    }

    internal byte R {
      get { return m_Color.R; }
    }

    internal byte G {
      get { return m_Color.G; }
    }

    internal byte B {
      get { return m_Color.B; }
    }

    /// <summary>
    /// Html kd barvy
    /// </summary>
    public string HtmlColor {
      get { return ColorTranslator.ToHtml(m_Color); }
    }

    /// <summary>
    /// Serializacn hodnota barvy (odpovd Color.ToArgb())
    /// </summary>
    public int Argb {
      get { return m_Color.ToArgb(); }
      set { m_Color = Color.FromArgb(value); }
    }
  }
}
