using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace Barbar.MapReport.DataSource.Esri {
  /// <summary>
  /// Reprezentuje Shp soubor jako celek
  /// </summary>
  public class ShpFile {
    ShpHeader m_Header;
    List<ShpRecord> m_Records = new List<ShpRecord>();

    /// <summary>
    /// Odkaz na hlavicku Shp souboru
    /// </summary>
    public ShpHeader Header {
      get { return m_Header; }
    }

    /// <summary>
    /// Seznam zznamu v Shp souboru
    /// </summary>
    public IList<ShpRecord> Records {
      get { return m_Records; }
    }

    /// <summary>
    /// Vytvor nov Shp soubor
    /// </summary>
    /// <param name="stream">Stream reprezentujc Shp soubor</param>
    public ShpFile(Stream stream) {
      m_Header = new ShpHeader(stream);
      int index = 0;
      while (stream.Position < m_Header.FileLength * 2) {
        ShpRecord record = new ShpRecord(stream, index++);
        m_Records.Add(record);
      }
      if (stream.Position != m_Header.FileLength * 2)
        throw new ShpException("Shp file corrupted.");
    }
  }
}
