using System;
using System.Collections.Generic;
using System.Text;
using System.Xml.Serialization;
using System.Collections.ObjectModel;

namespace Barbar.MapReport.DataSource {
  public class Region {
    private string m_Id;
    private string m_Name;
    private Region m_Parent;
    private Collection<Region> m_Children = new Collection<Region>();

    public Region() {
    }

    public Region(IRawRegion rawRegion) {
      m_Id = rawRegion.Id;
      m_Name = rawRegion.Name;
    }

    /// <summary>
    /// Id regionu
    /// </summary>
    public string Id {
      get { return m_Id; }
    }

    /// <summary>
    /// Nzev regionu
    /// </summary>
    public string Name {
      get { return m_Name; }
    }

    public Region Parent {
      get { return m_Parent; }
      internal set { m_Parent = value; }
    }

    internal Collection<Region> InternalChildren {
      get { return m_Children; }
    }

    public ReadOnlyCollection<Region> Children {
      get { return new ReadOnlyCollection<Region>(m_Children); }
    }
  }
}
