﻿using System;
using System.Collections.Generic;
using System.Text;
using Barbar.MapReport.Configuration;
using System.IO;
using System.Xml;
using System.Xml.Serialization;
using System.Collections.Specialized;
using Barbar.MapReport.DataSource.Resources;
using System.Web;

namespace Barbar.MapReport.DataSource {
  internal class ZoomLevelProviderFile : ZoomLevelProvider {
    private string m_Path;

    public override void Initialize(string name, NameValueCollection config) {
      base.Initialize(name, config);
      if (config == null)
        throw new ArgumentNullException("config");

      m_Path = config["path"];
      if (String.IsNullOrEmpty(m_Path))
        throw new DataSourceException(Translator.Error_PathNotSpecified);

      if (HttpContext.Current != null && m_Path.StartsWith("~", StringComparison.Ordinal)) {
        m_Path = HttpContext.Current.Server.MapPath(m_Path);
      }

      if (!File.Exists(m_Path))
        throw new DataSourceException(Translator.Error_FileNotFound);
    }

    public override ZoomLevelCollection ZoomLevels {
      get {
        FileInfo fileInfo = new FileInfo(m_Path);
        ZoomLevelCollection result;
        using (FileStream stream = fileInfo.OpenRead()) {
          XmlSerializer serializer = new XmlSerializer(typeof(ZoomLevelCollection), Constants.DataSourceXmlNamespace);
          result = (ZoomLevelCollection)serializer.Deserialize(stream);
        }
        return result;
      }
    }
  }
}
