using System;
using System.Collections.Generic;
using System.Text;
using System.Xml.Serialization;
using System.Net;
using Barbar.MapReport.Common;

namespace Barbar.MapReport.GeoCoding {
  /// <summary>
  /// Odpove na geo request 
  /// </summary>
  [XmlTypeAttribute(Namespace = "http://codeplex.com/MapReport/Service.asmx")]
  public class GeocoderResponse {
    private bool m_RequestOk;
    private string m_Xml;
    private GeoPoint[] m_Points;
    private string m_ExceptionDetail;

    /// <summary>
    /// Geokdovac sluba odpovedela na zznam
    /// </summary>
    public bool RequestOk {
      get { return m_RequestOk; }
      set { m_RequestOk = value; }
    }
    
    /// <summary>
    /// Raw XML vrcen z geokdovac sluby
    /// </summary>
    public string Xml {
      get { return m_Xml; }
      set { m_Xml = value; }
    }
    
    /// <summary>
    /// GPS Body odpovdajc requestu, nebo przdn pole
    /// </summary>
    [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Performance", "CA1819:PropertiesShouldNotReturnArrays")]
    public GeoPoint[] Points {
      get { return m_Points; }
      set { m_Points = value; }
    }
    
    /// <summary>
    /// Detail chyby pri pokusu o geokdovac request
    /// </summary>
    public string ExceptionDetail {
      get { return m_ExceptionDetail; }
      set { m_ExceptionDetail = value; }
    }

    internal WebRequest Request;
    internal IAsyncResult Result;
  }
}
