﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Web.Services.Protocols;

namespace Barbar.MapReport.HtmlRender.Facade {
  /// <summary>
  /// Web metoda oznacená tímto atributem loguje vyjímky
  /// </summary>
  [AttributeUsage(AttributeTargets.Method)]
  public sealed class SoapDebuggingAttribute : SoapExtensionAttribute {
    private int m_Priority;

    /// <summary>
    /// Vrací DebuggingExtension
    /// </summary>
    public override Type ExtensionType {
      get { return typeof(SoapDebuggingExtension); }
    }

    /// <summary>
    /// Priorita
    /// </summary>
    public override int Priority {
      get { return m_Priority; }
      set { m_Priority = value; }
    }

    /// <summary>
    /// Výchozí konstruktor
    /// </summary>
    public SoapDebuggingAttribute() {
    }
  }
}
