﻿using System;
using System.Collections.Generic;
using System.Text;
using Barbar.MapReport.Common.Drawing.Commands;
using Barbar.MapReport.Common.Drawing;
using Barbar.MapReport.HtmlRender.Operations.ValueIndicators;

namespace Barbar.MapReport.HtmlRender.Operations {
  internal class AddDynamicValueIndicatorsOperation : RenderBaseOperation, IServerCallbackOperation {
    private AddDynamicValueIndicatorsCommand m_Command;

    public AddDynamicValueIndicatorsOperation(AddDynamicValueIndicatorsCommand command) {
      m_Command = command;
    }

    #region RenderBaseOperation Members

    protected override void RenderInternal(RenderingContext context) {
    }

    #endregion

    #region IServerCallbackOperation Members

    public DataLocation DataLocation {
      get { return m_Command.DataLocation; }
    }

    public MapCallbackService CallbackService {
      get { return new ValueIndicatorService(); }
    }

    public object Value {
      get { return new ValueIndicatorCollection(m_Command); }
    }

    #endregion
  }
}
